version: "3"
services:
  api:
    build:
      context: ../api
      dockerfile: Dockerfile
      target: dev
    environment:
      MONGODB_URL: ${MONGODB_URL:-mongodb://mongo:27017/}
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.api.rule=Host(`localhost`) && (PathPrefix(`/wh`) || PathPrefix(`/data`) || PathPrefix(`/stats`))"
      - "traefik.http.routers.api.entrypoints=web"
    volumes:
      - ../api:/app
    ports:
      - "5000:5000"

  mongo:
    image: mongo:4.4
    ports:
      - "27017:27017"

  nats:
    image: nats:2.8-alpine
    ports:
      - "4222:4222"
  
  swagger:
    image: swaggerapi/swagger-ui:v4.15.5
    environment:
      - BASE_URL=/docs
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.doc.rule=Host(`localhost`) && PathPrefix(`/docs`)"
      - "traefik.http.routers.doc.entrypoints=web"
      - "traefik.http.services.doc.loadbalancer.server.port=8080"
    volumes:
      - $PWD/conf/openapi.yaml:/app/swagger.json
    ports:
      - "8082:8080"

  traefik:
    image: "traefik:v2.8"
    command:
      # - "--log.level=DEBUG"
      - "--api.insecure=true"
      - "--providers.docker=true"
      - "--providers.docker.exposedbydefault=true"
      - "--entrypoints.web.address=:80"
    ports:
      - "80:80"
      - "8080:8080"
      - "9999:9000"
    volumes:
      - "/var/run/docker.sock:/var/run/docker.sock:ro"
    
  wss:
    build:
      context: ../wss
      dockerfile: Dockerfile
      target: dev
    environment:
      MONGODB_URL: ${MONGODB_URL:-mongodb://mongo:27017/}
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.wss.rule=Host(`localhost`) && PathPrefix(`/ws`)"
      - "traefik.http.routers.wss.entrypoints=web"
      - "traefik.http.services.wss.loadbalancer.server.port=8080"
      - "traefik.http.middlewares.wss.stripprefix.prefixes=/ws"
    volumes:
      - ../wss/index.js:/app/index.js
      - ../wss/lib:/app/lib
    ports:
      - "8083:8080"
  
  www:
    build:
      context: ../www
      dockerfile: Dockerfile
      target: dev
    labels:
      - "traefik.enable=true"
      - "traefik.http.routers.www.rule=Host(`localhost`)"
      - "traefik.http.routers.www.entrypoints=web"
      - "traefik.http.services.www.loadbalancer.server.port=3000"
    volumes:
      - ../www:/app
    ports:
      - "3000:3000"